<script lang="ts">
	import { onMount } from 'svelte';
	import { ws } from '$lib/config';
	import { crossfade } from 'svelte/transition';
	import { flip } from 'svelte/animate';
	import type { Donor } from '$lib/donors';
	import Counter from '../Counter..svelte';
	import ReconnectingWebSocket from 'reconnecting-websocket';

	const [send, receive] = crossfade({});

	let tops: Donor[] = [];

	function getColor(i: number) {
		if (i === 1) {
			return '#FFD700';
		} else if (i === 2) {
			return '#C0C0C0';
		} else if (i === 3) {
			return '#CD7F32';
		} else {
			return;
		}
	}

	onMount(async () => {
		// Start WS
		const socket = new ReconnectingWebSocket(ws());

		socket.addEventListener('open', function (event) {
			socket.send(JSON.stringify({ op: 'sub', msg: `tops.lasts` }));
		});

		socket.addEventListener('message', function (event) {
			let data = JSON.parse(event.data);

			switch (data.r) {
				case `tops.lasts`:
					tops = data.d.dons;
					// reverse list
					tops.reverse();
					break;
				case `refresh`:
					// Refresh the page
					setTimeout(() => {
						window.location.reload();
					}, Math.random() * 1000);
					break;
			}
		});
	});
</script>

<div class="color flex flex-col w-screen h-screen items-center absolute top-0 -z-10">
	<div class="self-center">
		<div class="flex flex-col items-center text-7xl font-extrabold mt-5">
			<span class="mb-10 text-white"> Top donateurs : </span>
			<div class="text-xl font-extrabold" style="background-color:transparent">
				{#each tops as don, i (don.id)}
					<div
						class=" fredoka flex items-center"
						animate:flip
						in:receive={{ key: don.id, delay: i * 500 }}
						out:send={{ key: don.id, delay: i * 500 }}
						style="animation-delay: {i * 0.5}s"
					>
						<p
							class="rank"
							style={'font-size:2rem'}
						>
							{i + 1}
						</p>
						<div class="person flex items-center gap-1">
							<p class="person-name">
								{don.first_name}
								{don.last_name}
							</p>
							<p>a donné</p>
							<p class="counter">
								<Counter amount={don.amount} />
							</p>
							<p>€</p>
						</div>
					</div>
				{/each}
			</div>
		</div>
	</div>
</div>

<style>
	@import url('https://fonts.googleapis.com/css2?family=Fredoka:wght@300..700&display=swap');
	.fredoka {
		font-family: 'Fredoka', sans-serif;
		font-optical-sizing: auto;
		font-weight: 700;
		font-style: normal;
		font-variation-settings: 'wdth' 100;
	}
	.person {
		/* Widget with boxes */
		color: #fff;
		text-shadow: 0 0 10px #3333;
		background-color: rgba(223, 188, 112, 0.333);
		border: 3px solid #ae710055;
		border-radius: 40px;
		margin-top: 10px;
		padding: 15px 20px;
		font-size: 30px;
		font-weight: 800;
		max-width: 600px;
		line-height: 40px;
		white-space: nowrap;
		flex: 1;
	}
	.rank {
		padding: 0 5px;
		text-align: center;
		color: white;
		min-width: 50px;
		transition: all 1s ease-in-out;
		-webkit-text-stroke-width: 1px;
		-webkit-text-stroke-color: black;
	}
	.person-name {
		overflow: hidden;
		text-overflow: ellipsis;
		padding: 0 5px;
	}
	.counter {
		flex: 1;
		margin-left: 10px;
		font-size: 35px;
		text-shadow: none;
	}
	@keyframes slide-out-right {
		0% {
			-webkit-transform: translateX(0);
			transform: translateX(0);
			opacity: 1;
		}
		100% {
			-webkit-transform: translateX(1000px);
			transform: translateX(1000px);
			opacity: 0;
		}
	}
	@keyframes slide-out-right {
		0% {
			-webkit-transform: translateX(0);
			transform: translateX(0);
			opacity: 1;
		}
		100% {
			-webkit-transform: translateX(1000px);
			transform: translateX(1000px);
			opacity: 0;
		}
	}
	@keyframes slide-in-left {
		0% {
			-webkit-transform: translateX(-1000px);
			transform: translateX(-1000px);
			opacity: 0;
		}
		100% {
			-webkit-transform: translateX(0);
			transform: translateX(0);
			opacity: 1;
		}
	}
	@keyframes slide-in-left {
		0% {
			-webkit-transform: translateX(-1000px);
			transform: translateX(-1000px);
			opacity: 0;
		}
		100% {
			-webkit-transform: translateX(0);
			transform: translateX(0);
			opacity: 1;
		}
	}
</style>
